PFont font;
float hue = 360;
float saturation = 100;
float brightness = 100;
float alpha = 100;
String brush = "line";
String mode = "HSB";

Button save = new Button(24, 24, 32, 32, "save");
Button erase = new Button(24, 68, 32, 32, "erase");
Button lineBrush = new Button(700, 24, 32, 32, "line");
Button circleBrush = new Button(700, 68, 32, 32, "circle");
Button RGBMode = new Button(740, 24, 32, 32, "RGB");
Button HSBMode = new Button(740, 68, 32, 32, "HSB");
Slider hueS = new Slider(200, 24, 300, 32, 360, "hue");
Slider saturationS = new Slider(200, 68, 300, 32, 100, "saturation");
Slider brightnessS = new Slider(520, 24, 300, 32, 100, "brightness");
Slider alphaS = new Slider(520, 68, 300, 32, 100, "alpha");

void setup() {
  size(900,900);
  //fullScreen();
  colorMode(HSB, 360, 100, 100, 100);
  background(#333333);
  font = createFont("Arial Rounded MT Bold", 12);
  textFont(font);
  textAlign(CENTER, CENTER);
}

void draw() {
  if (mousePressed && (mouseButton == LEFT)) {
    if (mouseY > 92) {
      // Get brush direction
      PVector vec = new PVector (mouseX, mouseY);
      PVector vecP = new PVector (pmouseX, pmouseY);
      PVector step = new PVector ((vec.x - vecP.x), (vec.y - vecP.y));
      step.normalize();
      int d;
      if (step.x != 0)
        d = (int)(abs((vecP.x - vec.x) / step.x));
      else
        d = (int)(abs((vecP.y - vec.y) / step.y));
      
      // Draw brush     
      for (int i = 0; i <= d; i++) {
        if (brush == "line") {
          stroke(hue, saturation, brightness, alpha);
          strokeWeight(2);
          line(pmouseX + i * step.x + 5, pmouseY + i * step.y - 20, pmouseX + i * step.x - 5, pmouseY + i * step.y + 20);
        }
        if (brush == "circle") {
          noStroke();
          fill(hue, saturation, brightness, alpha);
          ellipse(pmouseX + i * step.x, pmouseY + i * step.y, 10, 10);
        }
      }
    }
    
    // Check if GUI is being used
    if (erase.used())
      erase();
    if (save.used())
      screen();
    if (lineBrush.used())
      brush = "line";
    if (circleBrush.used())
      brush = "circle";
    if (RGBMode.used())
      toRGB();
    if (HSBMode.used())
      toHSB();
    if (hueS.used()) {
      int val = mouseX + hueS._w / 2 - hueS._x;
      hue = map(val, 0, hueS._w, 0, hueS._range);
    }
    if (saturationS.used()) {
      int val = mouseX + saturationS._w / 2 - saturationS._x;
      saturation = map(val, 0, saturationS._w, 0, saturationS._range);
    }
    if (brightnessS.used()) {
      int val = mouseX + brightnessS._w / 2 - brightnessS._x;
      brightness = map(val, 0, brightnessS._w, 0, brightnessS._range);
    }
    if (alphaS.used()) {
      int val = mouseX + alphaS._w / 2 - alphaS._x;
      alpha = map(val, 0, alphaS._w, 0, alphaS._range);
    }
  }
  
  
  // GUI
  noStroke();
  fill(#666666);
  rect(0, 0, width, 92);
  
  save.show();
  erase.show();
  lineBrush.show();
  circleBrush.show();
  RGBMode.show();
  HSBMode.show();
  hueS.show();
  saturationS.show();
  brightnessS.show();
  alphaS.show();
  
  rectMode(CENTER);
  if (brush == "line") {
    noStroke();
    fill(#333333, 40);
    rect(lineBrush._x, lineBrush._y, lineBrush._w, lineBrush._h);
  }
  
  if (brush == "circle") {
    noStroke();
    fill(#333333, 40);
    rect(circleBrush._x, circleBrush._y, circleBrush._w, circleBrush._h);
  }
  
  if (mode == "RGB") {
    noStroke();
    fill(#333333, 40);
    rect(RGBMode._x, RGBMode._y, RGBMode._w, RGBMode._h);
  }
  
  if (mode == "HSB") {
    noStroke();
    fill(#333333, 40);
    rect(HSBMode._x, HSBMode._y, HSBMode._w, HSBMode._h);
  }
  rectMode(CORNER);
}

void keyPressed() {
  if (key == 'p')
    background(80);
}