class Slider {
  int _x, _y, _w, _h, _range;
  String _type;
  
  Slider(int x, int y, int w, int h, int range, String type) {
    _x = x;
    _y = y;
    _w = w;
    _h = h;
    _range = range;
    _type = type;
  }
  
  void show() {
    stroke(#333333);
    strokeWeight(2);
    noFill();
    rectMode(CENTER);
    rect(_x, _y, _w + 2, _h + 2);
    if (_type == "hue") {
      for (int i = 0; i <= _w; i++) {
        float val = map(i, 0, _w, 0, _range);
        stroke(val , saturation, brightness);
        line(_x - _w / 2 + i, _y - _h / 2, _x - _w / 2 + i, _y + _h / 2);
      }
      noFill();
      stroke(#333333);
      float val = map(hue, 0, _range, 0, _w);
      rect(val + _x - _w / 2, _y, 4, _h + 6);
    }
    
    if (_type == "saturation") {
      for (int i = 0; i <= _w; i++) {
        float val = map(i, 0, _w, 0, _range);
        stroke(hue , val, brightness);
        line(_x - _w / 2 + i, _y - _h / 2, _x - _w / 2 + i, _y + _h / 2);
      }
      noFill();
      stroke(#333333);
      float val = map(saturation, 0, _range, 0, _w);
      rect(val + _x - _w / 2, _y, 4, _h + 6);
    }
    
    if (_type == "brightness") {
      for (int i = 0; i <= _w; i++) {
        float val = map(i, 0, _w, 0, _range);
        stroke(hue , saturation, val);
        line(_x - _w / 2 + i, _y - _h / 2, _x - _w / 2 + i, _y + _h / 2);
      }
      noFill();
      stroke(#333333);
      float val = map(brightness, 0, _range, 0, _w);
      rect(val + _x - _w / 2, _y, 4, _h + 6);
    }
    
    if (_type == "alpha") {
      for (int i = 0; i <= _w; i++) {
        float val = map(i, 0, _w, 0, _range);
        stroke(hue , saturation, brightness, val);
        line(_x - _w / 2 + i, _y - _h / 2, _x - _w / 2 + i, _y + _h / 2);
      }
      noFill();
      stroke(#333333);
      float val = map(alpha, 0, _range, 0, _w);
      rect(val + _x - _w / 2, _y, 4, _h + 6);
    }
    
    rectMode(CORNER);
  }
  
  Boolean used() {
    return (mouseX >= _x - (_w / 2)) && (mouseX <= _x + (_w / 2)) && 
           (mouseY >= _y - _h / 2) && (mouseY <= _y + _h / 2);
  }
}